//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3E9D674C038B.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3E9D674C038B.cm

//## begin module%3E9D674C038B.cp preserve=no
//## end module%3E9D674C038B.cp

//## Module: FunctionUtility%3E9D674C038B; Package specification
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/FunctionUtils/FunctionUtility.h

#ifndef FUNCTIONUTILITY_H
#define FUNCTIONUTILITY_H 1

//## begin module%3E9D674C038B.additionalIncludes preserve=no
//## end module%3E9D674C038B.additionalIncludes

//## begin module%3E9D674C038B.includes preserve=yes
//## end module%3E9D674C038B.includes

// vector
#include <vector>
// string
#include <string>
// Error
#include <XSUtil/Error/Error.h>
//## begin module%3E9D674C038B.declarations preserve=no
//## end module%3E9D674C038B.declarations

//## begin module%3E9D674C038B.additionalDeclarations preserve=yes
//## end module%3E9D674C038B.additionalDeclarations


//## begin FunctionUtility%3E9D6558038D.preface preserve=yes
#include <map>
//## end FunctionUtility%3E9D6558038D.preface

//## Class: FunctionUtility%3E9D6558038D; Class Utility
//## Category: XSUtil::FunctionUtils%48DBD01C0111
//## Subsystem: XSUtil::FunctionUtils%48DBCC590164
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class FunctionUtility 
{
  //## begin FunctionUtility%3E9D6558038D.initialDeclarations preserve=yes
  //## end FunctionUtility%3E9D6558038D.initialDeclarations

  public:
    //## Class: NoInitializer%3E9D81750275
    //## Category: XSUtil::FunctionUtils%48DBD01C0111
    //## Subsystem: XSUtil::FunctionUtils%48DBCC590164
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class NoInitializer : public YellowAlert  //## Inherits: <unnamed>%3E9D81E10009
    {
      public:
        //## Constructors (generated)
          NoInitializer();

        //## Constructors (specified)
          //## Operation: NoInitializer%3E9D81900134
          NoInitializer (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: InvalidAbundanceFile%3E9DC8DD028F
    //## Category: XSUtil::FunctionUtils%48DBD01C0111
    //## Subsystem: XSUtil::FunctionUtils%48DBCC590164
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class InvalidAbundanceFile : public YellowAlert  //## Inherits: <unnamed>%3E9DC91A002B
    {
      public:
        //## Constructors (specified)
          //## Operation: InvalidAbundanceFile%3E9DC8F1036C
          InvalidAbundanceFile (const string& diag);

      protected:
      private:
      private: //## implementation
    };

    //## Class: FunctionException%3FFEC7C60159
    //## Category: XSUtil::FunctionUtils%48DBD01C0111
    //## Subsystem: XSUtil::FunctionUtils%48DBCC590164
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    class FunctionException : public YellowAlert  //## Inherits: <unnamed>%3FFEC7FF0133
    {
      public:
        //## Constructors (specified)
          //## Operation: FunctionException%3FFEC7DE005D
          FunctionException (const string& diag);

      protected:
      private:
      private: //## implementation
    };

  private:
    //## Class: Cosmology%40A4F5C80130; private
    //## Category: XSUtil::FunctionUtils%48DBD01C0111
    //## Subsystem: XSUtil::FunctionUtils%48DBCC590164
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Cosmology 
    {
        //## Constructors (specified)
          //## Operation: Cosmology%40A4F6EF0004
          Cosmology ();

        // Data Members for Class Attributes

          //## Attribute: H0%40A4F633008E
          //## begin FunctionUtility::Cosmology::H0%40A4F633008E.attr preserve=no  public: float {U} 
          float H0;
          //## end FunctionUtility::Cosmology::H0%40A4F633008E.attr

          //## Attribute: q0%40A4F677028E
          //## begin FunctionUtility::Cosmology::q0%40A4F677028E.attr preserve=no  public: float {U} 
          float q0;
          //## end FunctionUtility::Cosmology::q0%40A4F677028E.attr

          //## Attribute: lambda0%40A4F6B0006F
          //## begin FunctionUtility::Cosmology::lambda0%40A4F6B0006F.attr preserve=no  public: float {U} 
          float lambda0;
          //## end FunctionUtility::Cosmology::lambda0%40A4F6B0006F.attr

      public:
      protected:
      private:
      private: //## implementation
    };

  public:

    //## Other Operations (specified)
      //## Operation: checkXsect%3E9D7DBE00A8
      static bool checkXsect (const string& arg);

      //## Operation: checkAbund%3E9D7DF901A0
      static bool checkAbund (const string& arg);

      //## Operation: readInitializers%3E9D84820256
      static void readInitializers (string& xsects, string& abunds);

      //## Operation: readNewAbundances%3E9D85010265
      static void readNewAbundances (const string& file);

      //## Operation: getAbundance%3E9D957703C6
      static float getAbundance (const string& element);

      //## Operation: elements%3E9F155A01F5
      static const string& elements (size_t index);

      //## Operation: getModelString%3F980A720395
      static const string& getModelString (const string& key);

      //## Operation: setModelString%3F9814320378
      static void setModelString (const string& key, const string& value);

      //## Operation: eraseModelStringDataBase%40859D5E02EB
      static void eraseModelStringDataBase ();

      //## Operation: getH0%40A500F900F7
      static float getH0 ();

      //## Operation: getq0%40A5012E032E
      static float getq0 ();

      //## Operation: getlambda0%40A501A4005F
      static float getlambda0 ();

      //## Operation: setH0%40A501CD02A0
      static void setH0 (float H0);

      //## Operation: setq0%40A501FE037D
      static void setq0 (float q0);

      //## Operation: setlambda0%40A50228037E
      static void setlambda0 (float lambda0);

      //## Operation: setFunctionCosmoParams%40A51AF0021C
      static void setFunctionCosmoParams (double H0, double q0, double lambda0);

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: XSECT%3E9D6704026E
      static const string& XSECT ();
      static void XSECT (const string& value);

      //## Attribute: ABUND%3E9D67310032
      static const string& ABUND ();
      static void ABUND (const string& value);

      //## Attribute: abundanceFile%3E9D84E5038E
      static const string& abundanceFile ();
      static void abundanceFile (const string& value);

      //## Attribute: managerPath%3E9D99B702CA
      static const string& managerPath ();
      static void managerPath (const string& value);

      //## Attribute: NELEMS%3E9DC11402BD
      static const size_t& NELEMS ();

      //## Attribute: modelDataPath%3F96E98A01F0
      static const string& modelDataPath ();
      static void modelDataPath (const string& value);

      //## Attribute: NOT_A_KEY%3F981CF702CD
      static const string& NOT_A_KEY ();

      //## Attribute: abundPath%41B9C798029D
      static const string& abundPath ();
      static void abundPath (const string& value);

      //## Attribute: abundChanged%41B9C7C10227
      static const bool abundChanged ();
      static void abundChanged (bool value);

      //## Attribute: xwriteChatter%44B413B30272
      static int xwriteChatter ();
      static void xwriteChatter (int value);

      //## Attribute: tempsDEM%48E3A2E303DD
      static std::vector<double>& tempsDEM ();

      //## Attribute: DEM%48E3A37F0042
      static std::vector<double>& DEM ();

    //## Get and Set Operations for Associations (generated)

      //## Association: XSFunctions::Elemental Abundances%3E9D7EA50094
      //## Role: FunctionUtility::abundanceVectors%3E9D7EA503D7
      //## Qualifier: table%3E9D7ECA004D; string
      static const std::vector< float >& abundanceVectors (string table);
      static void abundanceVectors (string table, const std::vector< float >& value);

      //## Association: XSFunctions::Cross Section Tables%3E9D808400BF
      //## Role: FunctionUtility::crossSections%3E9D80840310
      //## Qualifier: table%3E9D80A40366; string
      static const std::string& crossSections (string table);
      static void crossSections (string table, const std::string& value);

      //## Association: XSFunctions::Abundance Descriptions%3E9DD2070347
      //## Role: FunctionUtility::abundDoc%3E9DD208014F
      //## Qualifier: name%3E9DD2580305; string
      static const std::string abundDoc (string name);
      static void abundDoc (string name, std::string value);

      //## Association: XSFunctions::<unnamed>%3F98098B01C5
      //## Role: FunctionUtility::modelStringDataBase%3F98098C00CC
      //## Qualifier: stringName%3F9809A302A5; string
      static const std::map<string,std::string>& modelStringDataBase ();

    // Additional Public Declarations
      //## begin FunctionUtility%3E9D6558038D.public preserve=yes
      //## end FunctionUtility%3E9D6558038D.public

  protected:
    // Additional Protected Declarations
      //## begin FunctionUtility%3E9D6558038D.protected preserve=yes
      //## end FunctionUtility%3E9D6558038D.protected

  private:
    // Additional Private Declarations
      //## begin FunctionUtility%3E9D6558038D.private preserve=yes
      //## end FunctionUtility%3E9D6558038D.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin FunctionUtility::XSECT%3E9D6704026E.attr preserve=no  public: static string {U} "bcmc"
      static string s_XSECT;
      //## end FunctionUtility::XSECT%3E9D6704026E.attr

      //## begin FunctionUtility::ABUND%3E9D67310032.attr preserve=no  public: static string {U} "angr"
      static string s_ABUND;
      //## end FunctionUtility::ABUND%3E9D67310032.attr

      //## Attribute: CROSSSECTFILE%3E9D84B100FC
      //## begin FunctionUtility::CROSSSECTFILE%3E9D84B100FC.attr preserve=no  private: static string {UC} "crosssections.dat"
      static const string CROSSSECTFILE;
      //## end FunctionUtility::CROSSSECTFILE%3E9D84B100FC.attr

      //## begin FunctionUtility::abundanceFile%3E9D84E5038E.attr preserve=no  public: static string {U} "abundances.dat"
      static string s_abundanceFile;
      //## end FunctionUtility::abundanceFile%3E9D84E5038E.attr

      //## Attribute: elements%3E9D902602B7
      //## begin FunctionUtility::elements%3E9D902602B7.attr preserve=no  private: static std::vector<string> {U} 
      static std::vector<string> s_elements;
      //## end FunctionUtility::elements%3E9D902602B7.attr

      //## begin FunctionUtility::managerPath%3E9D99B702CA.attr preserve=no  public: static string {U} ""
      static string s_managerPath;
      //## end FunctionUtility::managerPath%3E9D99B702CA.attr

      //## begin FunctionUtility::NELEMS%3E9DC11402BD.attr preserve=no  public: static size_t {UC} 30
      static const size_t s_NELEMS;
      //## end FunctionUtility::NELEMS%3E9DC11402BD.attr

      //## begin FunctionUtility::modelDataPath%3F96E98A01F0.attr preserve=no  public: static string {U} ""
      static string s_modelDataPath;
      //## end FunctionUtility::modelDataPath%3F96E98A01F0.attr

      //## begin FunctionUtility::NOT_A_KEY%3F981CF702CD.attr preserve=no  public: static string {U} "$$NOT$$"
      static string s_NOT_A_KEY;
      //## end FunctionUtility::NOT_A_KEY%3F981CF702CD.attr

      //## Attribute: COSMO%40A4F76D0000
      //## begin FunctionUtility::COSMO%40A4F76D0000.attr preserve=no  private: static FunctionUtility::Cosmology {U} FunctionUtility::Cosmology()
      static FunctionUtility::Cosmology s_COSMO;
      //## end FunctionUtility::COSMO%40A4F76D0000.attr

      //## begin FunctionUtility::abundPath%41B9C798029D.attr preserve=no  public: static string {U} 
      static string s_abundPath;
      //## end FunctionUtility::abundPath%41B9C798029D.attr

      //## begin FunctionUtility::abundChanged%41B9C7C10227.attr preserve=no  public: static bool {U} false
      static bool s_abundChanged;
      //## end FunctionUtility::abundChanged%41B9C7C10227.attr

      //## begin FunctionUtility::xwriteChatter%44B413B30272.attr preserve=no  public: static int {U} 10
      static int s_xwriteChatter;
      //## end FunctionUtility::xwriteChatter%44B413B30272.attr

      //## begin FunctionUtility::tempsDEM%48E3A2E303DD.attr preserve=no  public: static std::vector<double> {U} 
      static std::vector<double> s_tempsDEM;
      //## end FunctionUtility::tempsDEM%48E3A2E303DD.attr

      //## begin FunctionUtility::DEM%48E3A37F0042.attr preserve=no  public: static std::vector<double> {U} 
      static std::vector<double> s_DEM;
      //## end FunctionUtility::DEM%48E3A37F0042.attr

    // Data Members for Associations

      //## Association: XSFunctions::Elemental Abundances%3E9D7EA50094
      //## begin FunctionUtility::abundanceVectors%3E9D7EA503D7.role preserve=no  public: std::vector< float > { -> 1..nVHgN}
      static std::map<string,std::vector< float > > s_abundanceVectors;
      //## end FunctionUtility::abundanceVectors%3E9D7EA503D7.role

      //## Association: XSFunctions::Cross Section Tables%3E9D808400BF
      //## begin FunctionUtility::crossSections%3E9D80840310.role preserve=no  public: std::string { -> 1..nRHN}
      static std::map<string,std::string> s_crossSections;
      //## end FunctionUtility::crossSections%3E9D80840310.role

      //## Association: XSFunctions::Abundance Descriptions%3E9DD2070347
      //## begin FunctionUtility::abundDoc%3E9DD208014F.role preserve=no  public: std::string { -> 1RHN}
      static std::map<string,std::string> s_abundDoc;
      //## end FunctionUtility::abundDoc%3E9DD208014F.role

      //## Association: XSFunctions::<unnamed>%3F98098B01C5
      //## begin FunctionUtility::modelStringDataBase%3F98098C00CC.role preserve=no  public: std::string { -> 1..nVHgN}
      static std::map<string,std::string> s_modelStringDataBase;
      //## end FunctionUtility::modelStringDataBase%3F98098C00CC.role

    // Additional Implementation Declarations
      //## begin FunctionUtility%3E9D6558038D.implementation preserve=yes
      //## end FunctionUtility%3E9D6558038D.implementation

};

//## begin FunctionUtility%3E9D6558038D.postscript preserve=yes
//## end FunctionUtility%3E9D6558038D.postscript

// Class FunctionUtility::NoInitializer 

// Class FunctionUtility::InvalidAbundanceFile 

// Class FunctionUtility::FunctionException 

// Class FunctionUtility::Cosmology 

// Class Utility FunctionUtility 


//## Other Operations (inline)
inline float FunctionUtility::getH0 ()
{
  //## begin FunctionUtility::getH0%40A500F900F7.body preserve=yes
  return s_COSMO.H0;
  //## end FunctionUtility::getH0%40A500F900F7.body
}

inline float FunctionUtility::getq0 ()
{
  //## begin FunctionUtility::getq0%40A5012E032E.body preserve=yes
  return s_COSMO.q0;
  //## end FunctionUtility::getq0%40A5012E032E.body
}

inline float FunctionUtility::getlambda0 ()
{
  //## begin FunctionUtility::getlambda0%40A501A4005F.body preserve=yes
  return s_COSMO.lambda0;
  //## end FunctionUtility::getlambda0%40A501A4005F.body
}

inline void FunctionUtility::setH0 (float H0)
{
  //## begin FunctionUtility::setH0%40A501CD02A0.body preserve=yes
  s_COSMO.H0 = H0;
  //## end FunctionUtility::setH0%40A501CD02A0.body
}

inline void FunctionUtility::setq0 (float q0)
{
  //## begin FunctionUtility::setq0%40A501FE037D.body preserve=yes
  s_COSMO.q0 = q0;
  //## end FunctionUtility::setq0%40A501FE037D.body
}

inline void FunctionUtility::setlambda0 (float lambda0)
{
  //## begin FunctionUtility::setlambda0%40A50228037E.body preserve=yes
  s_COSMO.lambda0 = lambda0;
  //## end FunctionUtility::setlambda0%40A50228037E.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const string& FunctionUtility::XSECT ()
{
  //## begin FunctionUtility::XSECT%3E9D6704026E.get preserve=no
  return s_XSECT;
  //## end FunctionUtility::XSECT%3E9D6704026E.get
}

inline const string& FunctionUtility::ABUND ()
{
  //## begin FunctionUtility::ABUND%3E9D67310032.get preserve=no
  return s_ABUND;
  //## end FunctionUtility::ABUND%3E9D67310032.get
}

inline const string& FunctionUtility::abundanceFile ()
{
  //## begin FunctionUtility::abundanceFile%3E9D84E5038E.get preserve=no
  return s_abundanceFile;
  //## end FunctionUtility::abundanceFile%3E9D84E5038E.get
}

inline void FunctionUtility::abundanceFile (const string& value)
{
  //## begin FunctionUtility::abundanceFile%3E9D84E5038E.set preserve=no
  s_abundanceFile = value;
  //## end FunctionUtility::abundanceFile%3E9D84E5038E.set
}

inline const string& FunctionUtility::managerPath ()
{
  //## begin FunctionUtility::managerPath%3E9D99B702CA.get preserve=no
  return s_managerPath;
  //## end FunctionUtility::managerPath%3E9D99B702CA.get
}

inline void FunctionUtility::managerPath (const string& value)
{
  //## begin FunctionUtility::managerPath%3E9D99B702CA.set preserve=no
  s_managerPath = value;
  //## end FunctionUtility::managerPath%3E9D99B702CA.set
}

inline const size_t& FunctionUtility::NELEMS ()
{
  //## begin FunctionUtility::NELEMS%3E9DC11402BD.get preserve=no
  return s_NELEMS;
  //## end FunctionUtility::NELEMS%3E9DC11402BD.get
}

inline const string& FunctionUtility::modelDataPath ()
{
  //## begin FunctionUtility::modelDataPath%3F96E98A01F0.get preserve=no
  return s_modelDataPath;
  //## end FunctionUtility::modelDataPath%3F96E98A01F0.get
}

inline void FunctionUtility::modelDataPath (const string& value)
{
  //## begin FunctionUtility::modelDataPath%3F96E98A01F0.set preserve=no
  s_modelDataPath = value;
  //## end FunctionUtility::modelDataPath%3F96E98A01F0.set
}

inline const string& FunctionUtility::NOT_A_KEY ()
{
  //## begin FunctionUtility::NOT_A_KEY%3F981CF702CD.get preserve=no
  return s_NOT_A_KEY;
  //## end FunctionUtility::NOT_A_KEY%3F981CF702CD.get
}

inline const string& FunctionUtility::abundPath ()
{
  //## begin FunctionUtility::abundPath%41B9C798029D.get preserve=no
  return s_abundPath;
  //## end FunctionUtility::abundPath%41B9C798029D.get
}

inline void FunctionUtility::abundPath (const string& value)
{
  //## begin FunctionUtility::abundPath%41B9C798029D.set preserve=no
  s_abundPath = value;
  //## end FunctionUtility::abundPath%41B9C798029D.set
}

inline const bool FunctionUtility::abundChanged ()
{
  //## begin FunctionUtility::abundChanged%41B9C7C10227.get preserve=no
  return s_abundChanged;
  //## end FunctionUtility::abundChanged%41B9C7C10227.get
}

inline void FunctionUtility::abundChanged (bool value)
{
  //## begin FunctionUtility::abundChanged%41B9C7C10227.set preserve=no
  s_abundChanged = value;
  //## end FunctionUtility::abundChanged%41B9C7C10227.set
}

inline int FunctionUtility::xwriteChatter ()
{
  //## begin FunctionUtility::xwriteChatter%44B413B30272.get preserve=no
  return s_xwriteChatter;
  //## end FunctionUtility::xwriteChatter%44B413B30272.get
}

inline void FunctionUtility::xwriteChatter (int value)
{
  //## begin FunctionUtility::xwriteChatter%44B413B30272.set preserve=no
  s_xwriteChatter = value;
  //## end FunctionUtility::xwriteChatter%44B413B30272.set
}

inline std::vector<double>& FunctionUtility::tempsDEM ()
{
  //## begin FunctionUtility::tempsDEM%48E3A2E303DD.get preserve=no
  return s_tempsDEM;
  //## end FunctionUtility::tempsDEM%48E3A2E303DD.get
}

inline std::vector<double>& FunctionUtility::DEM ()
{
  //## begin FunctionUtility::DEM%48E3A37F0042.get preserve=no
  return s_DEM;
  //## end FunctionUtility::DEM%48E3A37F0042.get
}

//## Get and Set Operations for Associations (inline)

inline void FunctionUtility::abundanceVectors (string table, const std::vector< float >& value)
{
  //## begin FunctionUtility::abundanceVectors%3E9D7EA503D7.qualset preserve=no
  s_abundanceVectors[table] = value;
  //## end FunctionUtility::abundanceVectors%3E9D7EA503D7.qualset
}

inline void FunctionUtility::crossSections (string table, const std::string& value)
{
  //## begin FunctionUtility::crossSections%3E9D80840310.qualset preserve=no
  s_crossSections[table] = value;
  //## end FunctionUtility::crossSections%3E9D80840310.qualset
}

inline void FunctionUtility::abundDoc (string name, std::string value)
{
  //## begin FunctionUtility::abundDoc%3E9DD208014F.qualset preserve=no
  s_abundDoc[name] = value;
  //## end FunctionUtility::abundDoc%3E9DD208014F.qualset
}

inline const std::map<string,std::string>& FunctionUtility::modelStringDataBase ()
{
  //## begin FunctionUtility::modelStringDataBase%3F98098C00CC.get preserve=no
  return s_modelStringDataBase;
  //## end FunctionUtility::modelStringDataBase%3F98098C00CC.get
}

//## begin module%3E9D674C038B.epilog preserve=yes
//## end module%3E9D674C038B.epilog


#endif
